package com.liang.dao;

import com.liang.entity.PrjAnnualbudget;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * 年度预算(PrjAnnualbudget)表数据库访问层
 *
 * @author makejava
 * @since 2023-05-17 08:56:50
 */
public interface PrjAnnualbudgetDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PrjAnnualbudget queryById(Integer id);

    /**
     * 通过任务书ID查询单条数据
     *
     * @param rws
     * @return
     */
    PrjAnnualbudget queryByRws(Integer rws);

    /**
     * 查询单条数据
     *
     * @param map
     * @return
     */
    PrjAnnualbudget getAnnualBudget(Map map);

    /**
     * 查询指定行数据
     *
     * @param prjAnnualbudget 查询条件
     * @param pageable        分页对象
     * @return 对象列表
     */
    List<PrjAnnualbudget> queryAllByLimit(PrjAnnualbudget prjAnnualbudget, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param prjAnnualbudget 查询条件
     * @return 总行数
     */
    long count(PrjAnnualbudget prjAnnualbudget);

    /**
     * 撤销数据（基本信息）
     *
     * @param prjAnnualbudget 实例对象
     * @return 影响行数
     */
    int tjrevokeApprove(PrjAnnualbudget prjAnnualbudget);

    /**
     * 新增数据
     *
     * @param prjAnnualbudget 实例对象
     * @return 影响行数
     */
    int insert(PrjAnnualbudget prjAnnualbudget);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjAnnualbudget> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<PrjAnnualbudget> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<PrjAnnualbudget> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<PrjAnnualbudget> entities);

    /**
     * 修改数据
     *
     * @param prjAnnualbudget 实例对象
     * @return 影响行数
     */
    int update(PrjAnnualbudget prjAnnualbudget);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 获取年度预算列表
     *
     * @return
     */
    List<PrjAnnualbudget> getNdysList(Map map);

    /**
     * 获取年份列表
     *
     * @return
     */
    List<String> getYearList();

    /**
     * 批量删除年度预算
     *
     * @param idList
     * @return
     */
    int batchDelete(List<Integer> idList);

    /**
     * 修改审批状态
     *
     * @param annualbudget 实例对象
     * @return 实例对象
     */
    int updateSpzt(PrjAnnualbudget annualbudget);

    List<PrjAnnualbudget> listByRws(Integer rws);

    void updateXTJSYZX(Integer rws);

    void updateSJYZX(Integer rws);

    void updateSJYZXByBZID(@Param("bzId") Integer bzId, @Param("nysSum") BigDecimal nysSum);

    BigDecimal getNYSSum(@Param("id") Integer id, @Param("rwsId") Integer rwsId);

    void updateSJYZXSum(Integer rws);

    PrjAnnualbudget queryByRws1(@Param("rws") Integer rws, @Param("nf") Integer nf);

    void updateXTJSYZXByNysId(@Param("rwsId") Integer rwsId, @Param("nf") String nf, @Param("nysId") Integer nysId);

    void updateSJYZXByNysId(@Param("rwsId") Integer rwsId, @Param("nf") String nf, @Param("nysId") Integer nysId);

    void updateSJYZXSumByNysId(@Param("rwsId") Integer rwsId, @Param("nf") String nf, @Param("nysId") Integer nysId);

    void updateZFXMFYMC(@Param("nysId") Integer nysId, @Param("rwsId") Integer rwsId);

    void updateSXGSKJXMFYMC(@Param("nysId") Integer nysId, @Param("rwsId") Integer rwsId);

    void updateGWGSKJXMFYMC(@Param("nysId") Integer nysId, @Param("rwsId") Integer rwsId);

    void updateSFXG(Integer xmid);
}

